/**************************************************************************
**
** This file is part of Qt Creator
**
** Copyright (c) 2011 Nokia Corporation and/or its subsidiary(-ies).
**
** Contact: Nokia Corporation (info@qt.nokia.com)
**
**
** GNU Lesser General Public License Usage
**
** This file may be used under the terms of the GNU Lesser General Public
** License version 2.1 as published by the Free Software Foundation and
** appearing in the file LICENSE.LGPL included in the packaging of this file.
** Please review the following information to ensure the GNU Lesser General
** Public License version 2.1 requirements will be met:
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** Other Usage
**
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Nokia.
**
** If you have questions regarding the use of this file, please contact
** Nokia at info@qt.nokia.com.
**
**************************************************************************/

#ifndef BASETEXTEDITORUTIL_H
#define BASETEXTEDITORUTIL_H

#include "texteditor_global.h"

QT_BEGIN_NAMESPACE
class QTextDocument;
QT_END_NAMESPACE

#include <QtCore/QString>
#include <QtGui/QTextCursor>

namespace TextEditor {
namespace Convenience {

TEXTEDITOR_EXPORT bool convertPosition(const QTextDocument *document,
                                       int pos,
                                       int *line, int *column);

TEXTEDITOR_EXPORT QString textAt(QTextCursor tc, int pos, int length);

} // Util
} // TextEditor

#endif // BASETEXTEDITORUTIL_H
